unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, PaxCompiler, StdCtrls, PaxProgram, PaxJavaScriptLanguage;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    PaxJavaScriptLanguage1: TPaxJavaScriptLanguage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  t: Integer;
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxJavaScriptLanguage1);

  PaxCompiler1.RegisterHeader(0, 'function IntToStr(Value: Integer): string;', @IntToStr);
  PaxCompiler1.RegisterHeader(0, 'function StrToInt(const S: string): Integer;', @StrToInt);

  PaxCompiler1.AddModule('1', PaxJavaScriptLanguage1.LanguageName);

  PaxCompiler1.AddCode('1', 'var i, k;');
  PaxCompiler1.AddCode('1', '  for (i=1; i < 200000; i++)');
  PaxCompiler1.AddCode('1', '    k = StrToInt(IntToStr(i));');

  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    t := GetTickCount;
    PaxProgram1.Run;
    ShowMessage(IntToStr(GetTickCount - t));
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount - 1 do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I, K, t: Integer;
begin
  t := GetTickCount;
  for I:=1 to 200000 do
    K := StrToInt(IntToStr(I));
  ShowMessage(IntToStr(GetTickCount - t));
end;

end.
